#include "log.h"
#include "SEGGER_RTT.h"
#include "string.h"

/******************************************************
 *                      Macros
 ******************************************************/

/******************************************************
 *                    Constants
 ******************************************************/
#define BUFFERINDEX 0

/******************************************************
 *                 Type Definitions
 ******************************************************/

/******************************************************
 *               Static Function Declarations
 ******************************************************/

/******************************************************
 *               Variable Definitions
 ******************************************************/

static uint16_t loggersSelection = 0;

void LOG_Init()
{

}

void LOG_Activation(uint16_t LoggerIndex, bool state)
{
	if (state)
	{
		loggersSelection |= LoggerIndex;
	} else
	{
		loggersSelection &= ~LoggerIndex;
	}
}

int16_t LOG_printf(uint16_t LoggerIndex, const char * sFormat, ...)
{
	if ((loggersSelection & LoggerIndex) != LoggerIndex) return 0;

	int r;
	va_list ParamList;

	va_start(ParamList, sFormat);
	r = SEGGER_RTT_vprintf(BUFFERINDEX, sFormat, &ParamList);
	va_end(ParamList);
	return r;
}

int16_t LOG_WriteString(uint16_t LoggerIndex, const char* s)
{
	if ((loggersSelection & LoggerIndex) != LoggerIndex) return 0;

	unsigned Len;
  	Len = strlen(s);
  	return SEGGER_RTT_Write(BUFFERINDEX, s, Len);
}

